export { createFunctionResolver } from './potential/function';
export { createKeyListResolver } from './potential/key-list';
export { createObjectResolver } from './potential/object';
export { createKeyResolver } from './potential/single-key';
export { createValueResolver } from './potential/value';
export { createBoolBasedResolver } from './resolvers/bool-based';
export { createValueBasedResolver } from './resolvers/value-based';
export { createResolver } from './tools/create-resolver';
export { deprecatedCreateResult as createResult } from './tools/create-result';
export type { BoolBasedSelectiveOption, FunctionOption, KeyListOption, KeyOption, ObjectOption, SingleKeyOption, ValueBasedSelectiveOption, } from './types/input-types';
export type { BoolBasedResolver, KeyList, PotentialResolver, PotentiallyResolved, Resolved, Resolver, SpecialKeys, ValueBasedResolver, } from './types/resolver-types';
//# sourceMappingURL=index.d.ts.map