import type { AllowNullish, Nullish } from '../types/private-types';
import type { KeyList, PotentialResolver, SpecialKeys } from '../types/resolver-types';
export declare function createKeyListResolver<K extends string, S extends string>(keys: KeyList<K>, special: SpecialKeys<S, K>): PotentialResolver<K, boolean>;
export declare function createKeyListResolver<K extends string>(keys: KeyList<K>, special?: Nullish): PotentialResolver<K, boolean>;
export declare function createKeyListResolver<K extends string, S extends string>(keys: KeyList<K>, special?: AllowNullish<SpecialKeys<S, K>>): PotentialResolver<K, boolean>;
//# sourceMappingURL=key-list.d.ts.map