import type { TypeCheckFunction } from '../types/private-types';
import type { KeyList, PotentialResolver } from '../types/resolver-types';
export declare function createValueResolver<K extends string, V>(keys: KeyList<K>, isValidValue: TypeCheckFunction<V>, defaultValue: V): PotentialResolver<K, V>;
export declare function createValueResolver<K extends string, V, D = V>(keys: KeyList<K>, isValidValue: TypeCheckFunction<V>, defaultValue: D): PotentialResolver<K, V | D>;
//# sourceMappingURL=value.d.ts.map