import type { TypeCheckFunction } from '../types/private-types';
interface IsArrayFunction extends TypeCheckFunction<unknown[]>, TypeCheckFunction<readonly unknown[]> {
    <T extends readonly unknown[]>(value: unknown): value is T;
    <T extends unknown[]>(value: unknown): value is T;
    <T>(value: unknown): value is (readonly T[] | T[]);
}
export declare const isArray: IsArrayFunction;
export declare function is(value: unknown, type: 'object'): value is object | null;
export declare function is<T extends object | null | unknown[] | readonly unknown[]>(value: unknown, type: 'object'): value is T;
export declare function is(value: unknown, type: 'function'): value is CallableFunction;
export declare function is<T extends CallableFunction>(value: unknown, type: 'function'): value is T;
export declare function is(value: unknown, type: 'string'): value is string;
export {};
//# sourceMappingURL=is.d.ts.map