import type { Nullish, TypeCheckFunction, Void } from '../types/private-types';
type ValueOrNullishResult<V extends boolean, T> = [isValid: V, value: T];
type IsValidResult<V> = ValueOrNullishResult<true, V>;
type IsNullishResult = ValueOrNullishResult<false, Nullish>;
export declare function validateValue<V>(value: unknown, isValidValue: TypeCheckFunction<V>): IsValidResult<V> | IsNullishResult | Void;
export declare function validateValueOrThrow<V>(value: unknown, isValidValue: TypeCheckFunction<V>): IsValidResult<V> | IsNullishResult;
export {};
//# sourceMappingURL=value-nullish.d.ts.map